/*
    Product Revision  :  PIC10 / PIC12 / PIC16 / PIC18 MCUs - 1.81.8
    Device            :  PIC18F27K42
    Driver Version    :  2.00
    (c) 2018 Microchip Technology Inc. and its subsidiaries. 

*/

#include "mcc_generated_files/mcc.h"
#include "ctype.h"
#include <limits.h>
#include <string.h>

#define VERSION "250317"
#define MCU " 18F27K42"
#define POWER_SUPPLY " 5V "
#define DIR " C:\\MPLABX_PrOJECTS"
#define COMPILO "XC8 V2.36 C99"
#define PACK "PIC18F-K_DFP 1.6.125"

#ifndef _XTAL_FREQ
#define _XTAL_FREQ 64000000 
#endif

#define Directory "C:\\MPLABX_Projects\\18F27K42_PMW_CCP1234_2025"
#define Project  "18F27K42_PMW_CCP1234_2025"
#define Source   " main.c , rev :"
#define Annexe   " XC8 V2.36 C99  Pack: PIC18F-K_DFP 1.6.125"
#define Others   " LCD_4bits_I2C_2024-01, UART1_Functions.h , mcc.h," 
#define Add_Inc  " Dialogue_Operateur_PC_via_UART_2023-0905\r\n"
#define Eeprom   " Eeprom...........   "
#define Hardware " BASE 18F27K42 + I2C LCD4x20 + RTC DS3231 + UART1 115200" 
#define Config   " Internal Fosc 64MHz"
#define Schema   " Schma_Portail_V5-0-1 du 10-03.pdf by H.T.\r\n"

#define With_SQA_Analyser
#ifdef With_SQA_Analyser
#define SQA_Dir TRISCbits.TRISC5
#define SQA LATCbits.LATC5
#endif


#define CR 13
#define LF 10
#define TAB 9

#define With Led_Rouge   // utilise la sortie STOP
#ifdef With Led_Rouge
#define With Led_Rouge
#define Led_Rouge   LATAbits.LATA4
#define Led_Rouge_Dir   TRISAbits.TRISA4
#endif


#include "i2c1_master.h"
#include "i2c1_master_example.h"
#include "UART1_Functions.h"

#define With_LCD  
#ifdef With_LCD   // I2C !
#define LCD_ADDR 0x27  //PCF8574 inclus sur gros LCD 4x20 Bleu Paul sur Prtototype Breaboard
#include "LCD_4bits_I2C_2024-01.h"
#endif

const  char Msg0[]=" BASE 18F27K42 + LCD4X20+ PWM1,2,3,4 Analog RA0,1,2,3\r\n";
const  char Msg1[]=" Directory :"Directory"\r\n";
const  char Msg2[]=" Project : "Project"\r\n";
const  char Msg3[]=" Source : "Source"_"VERSION"\r\n";
const  char Msg4[]=" Config "Config"\r\n";
const  char Msg5[]=" Autres :\r\n "Others"\r\n";
const  char Msg6[]=" A inclure: \r\n"Add_Inc"\r\n";
const  char Msg7[]=" LCD_chars_Speciaux_2024.h,   Eeprom :"Eeprom"\r\n";
const  char Msg8[]=" Hardware :"Hardware"\r\n Schema:"Schema"\r\n";
const  char Msg9[]=" RA0=...RA1=Analog ,RA4=led,RA3...RC6=TX UART1 RC7=RX UART\r\n";
const  char MsgA[]=" RB0 ...\r\n";
const  char MsgB[]=" LCD 4x20 bus I2C1 HW : RC3=SCL,RC4=SDA\r\n";
const  char * Messages[]={Msg0,Msg1,Msg2,Msg3,Msg4,Msg5,Msg6,Msg7,Msg8,Msg9,MsgA,MsgB};
const  char Blancs[]="  ";

#define UART1_RX_BUFFER_SIZE 128 
  
// variables Globales usuelles 
unsigned int  i,j,k,l,m,n;
unsigned char  c1,c2,c3,cx,cc;
unsigned int Nb_Boucles=0;
volatile unsigned char Buffer1[UART1_RX_BUFFER_SIZE];
volatile unsigned int Index1,i1;
volatile unsigned char Flag_Buffer1=0;
char TEXTE [128];
char * txt;
bool Status_GIE_Bit;  
// pointeurs 
unsigned char * p0;
unsigned char * p1;
unsigned char * px;
char CRam1[128];
unsigned char Tampon[32];
float F0,F1,F2,F3,F4;

volatile uint16_t Cpt0, Cpt1, Cpt3, Cpt6;    
volatile uint8_t Flag_Timer0=0;
volatile uint8_t Flag_Timer1=0;
volatile uint8_t Flag_Timer6=0;
volatile uint8_t Flag_Eeprom=0; 
int Etat;
bool Status_GIE_Bit;
char Dummy;

//unsigned long SMT1_Measure;
//unsigned  char *ST;
unsigned long  L1=0;
unsigned long  L2=0;
unsigned long  L3=0;
//  I2C  LCD ,MCP
volatile unsigned char Addr;
unsigned char I2_Adresses_Devices[8];
unsigned char tmp[10]={0,0,0,0,0,0,0,0,0,0};


volatile struct Anybits {   // 8 flags
       unsigned  Tmr0_Elapsed:1;     // for timer0 16bits
       unsigned  Tmr1_Elapsed:1;     // for timer1 16bits
       unsigned  Tmr2_Elapsed:1;     // for timer2 8bits
       unsigned  Tmr3_Elapsed:1;     // for timer3 16bits
       unsigned  Tmr4_Elapsed:1;     // for timer4 8bits
       unsigned  Tmr6_Elapsed:1;     // for timer6 8bits
       unsigned  NCO_initialise:1;   // for NCO
       unsigned  Key_ON :1;          // detection appui BP
 }Drapeaux ;
 
int Duty_Value=0;
int Duree_Boucle=0;

char LCD_char12=' ';  // caractere variable en position 12 affichage repos LCD
char LCD_char15=' ';  // caractere variable en position 15 Affichage repos  LCD


//void  MAJ_RTC_Manuelle(void);
//unsigned char Dec2Bcd(uint8_t n);    
//unsigned char Bcd2Dec( uint8_t  val);

void Vectored_Interrupts_Init(void);
//void Hardware_Init();

//void TMR6_Init_500ms(char N);
//void SMT1_Init(char Choix_SMT1_Clock); // clock 64MHz,16Mhz,500Khz,31,25Khz
//void Init_I2C (void);
void I2C1_Write1ByteRegister(i2c1_address_t address, unsigned char reg, unsigned char data);
void I2C_PCF8574_Write(unsigned char  Addr , unsigned char value);

void  Vectored_Interrupts_Init(void)
{  //rev 25-10-2023
    INTCON0bits.GIE=0;
    INTCON0bits.IPEN = 1;
    INTCON0bits.GIEH = 0; // dis high priority interrupts
    INTCON0bits.GIEL = 0; // dis low priority interrupts*
     
    INTCON0bits.IPEN = 1; // Enable interrupt priority
   //  __asm("BCF INTCON0,GIE");
   // GIE = 0;
    IVTLOCK = 0x55;
    IVTLOCK = 0xAA;
    IVTLOCKbits.IVTLOCKED = 0x00; // unlock IVT
    IVTBASEU = 0;
    IVTBASEH = 0;
    IVTBASEL = 8;
    IVTLOCK = 0x55;
    IVTLOCK = 0xAA;
    IVTLOCKbits.IVTLOCKED = 0x01; // lock IVT
    // Assign peripheral interrupt priority vectors
    IPR3bits.U1RXIP = 1;
    IPR1bits.INT0IP = 1;
    IPR4bits.TMR1IP = 0;
    IPR3bits.TMR0IP = 0;
    IPR4bits.TMR2IP = 0;  // low priority
 //   IPR7bits.TMR4IP = 0;
//    IPR9bits.TMR6IP = 0;
    IPR0bits.IOCIP =  0;
  
    INTCON0bits.GIEL = 0; // disable low priority interrupts
    INTCON0bits.GIEH = 0; // disable high priority interrupts
    INTCON0bits.GIE=0;

}


void __interrupt(irq(IRQ_INT0),high_priority) INT0_ISR(void)
{  
   if( (INT0IE) && (INT0IF))
   {    
      Drapeaux.Key_ON=0;
          U1TXB='#';
       // __delay_ms(80);  
   }
  PIR0bits.IOCIF=0;
  IOCBF=0;
  INT0IF=0;   
}

void __interrupt(irq(IRQ_U1RX),high_priority) UART1_rx_vect_isr(void)
{
   static char cx;
  //  U1TXB='H';  // pour debugging only
  if ( (PIR3bits.U1RXIF==1) && (PIE3bits.U1RXIE ==1) )
  {   
      c1=U1RXB;  // => RAZ PIR3bits.U1RXIF
   //   U1TXB='*'; // echo
     if ( (c1==13) || (i1>UART1_RX_BUFFER_SIZE-1))
     { 
      Flag_Buffer1=1;
      Buffer1[i1]=0;
      Index1=i1;
      i1=0; 
     PIE3bits.U1RXIE =0;
     }
     else
     {
       Buffer1[i1]=c1;
       i1++;
       Index1=i1;
      } 
   } 
  // INTCON0bits.GIEL=0;
}

void __interrupt(irq(IRQ_TMR6),low_priority) TMR6_ISR(void)
{  
      if (Cpt6>0)  // decomptage maxi 32767
       {
         Cpt6--;
        }
      else
      {
        Drapeaux.Tmr6_Elapsed=1;
        TMR6IE=0;
      } 
     Flag_Timer6=1;
     TMR6IF=0;// clear the TMR6 interrupt flag

 }


void TMR6_Init_500ms(char N)
{   
    //  cycle=500 mS modifi -> 1sec !
     PIE9bits.TMR6IE=0 ;
     // T2PSYNC Not Synchronized; T2MODE Software control; T2CKPOL Rising Edge; T2CKSYNC Not Synchronized; 
    T6CLKCON = 0x05;    // T2CS FOSC/4 ou    0x05 pour 500Khz
    T6HLT = 0x00;
    T6TMR = 0x00;  // TMR4 0; 
    T6CON = 0x70 | 0x07 ; // Prescaler =7=> 1/128 Poscaler=7=>  1/8 =>  ticks= 512  S
    T6PR=244;   // 512 * (244+1) * 128 * 8 => 501760S ->  500mS sec
   Flag_Timer6=0;
   Drapeaux.Tmr6_Elapsed=0;
    TMR6IF=0;
   if(N>0) 
   { 
     Cpt6=N;
   }
   else
   {
     Cpt6=1;      
   } 
 PIE9bits.TMR6IE=1 ;  // TMR6IE_bit=1;
 TMR6IF=0;   
 TMR6ON = 1;
 }

void __delay_xSec( uint8_t N)
{
static uint8_t i2;  
for (i2 =0;i2<N;i2++)
{
    __delay_ms(1000);
}
}

void I2C_PCF8574_Write(unsigned char Adrp,unsigned char value)
{//rev 14-10-2023 
 char tmpx[2];
 tmpx[0]=value;
 tmpx[1]=0;
 I2C1_WriteNBytes(Adrp, tmpx, 1); 
  __delay_us(30);
} 


void Init_I2C (void)
{   
    I2C1CLK    = 0x03;      // I2C1 Clock Selection Register, MFINTOSC 500kHz ?? 100kHz ??  // doc p. 581
  // 2-04-2023  probleme maxi pCF SLC =100KHz
  //  I2C1CLK    = 0x06;    ///0110	 TMR2 post scaled output	42Khz theorique
  // SQA mesure  18.00+11.76=29.76S -> 33.6Khz ?? why ?
    I2C1CON0   = 0x04;      // I2C1 Control Register 0, Master mode, 7-bit Address  // doc p.577
    I2C1CON1   = 0x80;      // I2C1 Control Register 1, Acknowledge value transmitted after received data 
                            //(when I2CCNT=0) : 1 = NACK     (Not ACKnowledge)  // doc p.579
    I2C1CON2   = 0x00;      // I2C1 Control Register 2, envoi Start non auto, SDAHT 300ns hold time, BFRET 8 i2c clock pulses  // doc p.580
    I2C1CNT = 0;
 //   I2C1CON2bits.FME=1;
    I2C1CON2bits.ABD=0; //  ADB=0; // Transmitted Address data is loaded from the I2CxADB0/1 registers.
     // I2C1ADB1   = 0x3C;      //0x3C adresse bus I2C mini oled SSD1306
    I2C1ADB1   = 0x20 ;   //LCD_ADDR;   // LCD 2x16 avec PCF8754
    I2C1PIRbits.PCIF = 0;  // clear STOP bit flag
  //  I2C1CON2bits.ABD=1;   
    I2C1CON0bits.EN=0;   // i2c1 OFF   
}

 bool I2C1_DevicePresent(int16_t Address)
{
I2C1PIRbits.PCIF = 0;                // clear STOP bit flag
I2C1ADB1 = Address;                  // load slave Addr and R/W
I2C1CNT = 0;
I2C1CON0bits.S = 1;                  // send START + Addr
while (I2C1PIRbits.PCIF == 0);       // wait for STOP
return !I2C1CON1bits.ACKSTAT;
}

 
void Test_Presence_I2C_devices(void)
{
 int i,j;
 txt=&TEXTE[0]; 
 *(txt)=0;
// U1TXB='1';__delay_ms(20);
// I2C1CON2 = 0x00;  // <- OK
I2C1CON2bits.ABD=0; //  ADB=0; // Transmitted Address data is loaded from the I2CxADB0/1 registers.
 //U1TXB='2';__delay_ms(20);
I2C1CON0bits.EN = 1;
 //U1TXB='3';__delay_ms(20);
for (i=2; i<252; i=i+2)
{
if (I2C1_DevicePresent(i))
{
k=i>>1;
sprintf(txt," @ decimal #%4u  soit @Device 7bits = 0X%02X ",i,k);
//Print(txt);
switch (k)
{
case 0x20:// de base + 7 autres
case 0x21:
case 0x22:
case 0x23:
    //...etc 
case 0x27:
   strcat(txt," PCF8754 for LCD 2x16cars"); 
   break;
case 0x28:
case 0x29:
case 0x2A:
// case etc ..
strConstRamCpy(CRam1,"PCF8574 8bits IO" );  
j=strlen(txt);
strcpy(txt+j,CRam1);
//txt=strcat(txt,CRam1);// de base + 7 autres
break;
case 0x37:
     strcat(txt,"LCD 2119 2x16cars"); // de base + 7 autres
break;
case 0x38:
case 0x39:
case 0x3A:
case 0x3B:
// case etc ..
strcat(txt,"PCF8574A 8bits I/O"); // de base + 7 autres
break;
case 0x3C:
strcat(txt,"OLED SSD1306");
break;
case 0x57:
strcat(txt,"EEPROM 512bytes");
break;
case 0x68:
strcat(txt,"RTC DS3231");
break;
case 0xA0:
strcat(txt,"Eeprom 24LCxxx 256k ou 512K");
break;
default:
strcat(txt,"non recens");
break;
}
Print(txt);CRLF1();
}
}
I2C1CON0bits.EN = 0;
//I2C1CON2 = 0x18;
I2C1CON2bits.ABD=1;
CRLF1();
}


  
void Waiting_Enter_Key_Pressed(void)
{
      CPrint(" Pres Enter key !\r\n");
    //PIR3bits.U1RXIF=0;
     c1=U1RXB;
    while(PIR3bits.U1RXIF==0)
    { PrintChar('.');
     __delay_ms(100);
    }
     //PIR3bits.U1RXIF=0;
    c1=U1RXB;
    // PIR3bits.U1RXIF=0;   
}

void Hardware_Init()
{
    
    /**
    LATx registers
    */
    LATA = 0x00;
    LATB = 0x00;
    LATC = 0x00;

    /**
    TRISx registers
    */
    TRISA = 0xEF;
    TRISB = 0x9E;
    TRISC = 0x81;

    /**
    ANSELx registers
    */
    ANSELC = 0x66;
    ANSELB = 0x61;
    ANSELA = 0x0F;

    /**
    WPUx registers
    */
    WPUE = 0x00;
    WPUB = 0x00;
    WPUA = 0x00;
    WPUC = 0x00;

#ifdef With_SQA_Analyser
    SQA_Dir=0; //output RC5
    SQA=0; //LATC5
#endif   
#ifdef With Led_Rouge
    ANSELAbits.ANSELA4=0;
    TRISAbits.TRISA4 = 0;
    Led_Rouge_Dir=0; //RA4 en sortie
    Led_Rouge=0; //RA4
    //>>> Le port STOP, initialement partag avec PGC, passe en RA4
#endif 
    
    
    
    /**
    RxyI2C registers
    */
    RB1I2C = 0x00;
    RB2I2C = 0x00;
    RC3I2C = 0x00;
    RC4I2C = 0x00;

    /**
    ODx registers
    */
    ODCONA = 0x00;
    ODCONB = 0x00;
    ODCONC = 0x18;

    /**
    SLRCONx registers
    */
    SLRCONA = 0xFF;
    SLRCONB = 0xFF;
    SLRCONC = 0xFF;

    /**
    INLVLx registers
    */
    INLVLA = 0xFF;
    INLVLB = 0xFF;
    INLVLC = 0xFF;
    INLVLE = 0x08;

     RC2PPS = 0x09;   //RC2->CCP1:CCP1;   
     RC1PPS = 0x0A;   //RC1->CCP2:CCP2; 
     RB5PPS = 0x0B;   //RB5->CCP3:CCP3; 
     RB0PPS = 0x0C;   //RB0->CCP4:CCP4;    
	
    I2C1SDAPPS = 0x14;   //RC4->I2C1:SDA1;    
    RC3PPS = 0x21;   //RC3->I2C1:SCL1;    
    RC4PPS = 0x22;   //RC4->I2C1:SDA1;    
    
    RC6PPS = 0x13;   //RC6->UART1:TX1;    
    U1RXPPS = 0x17;   //RC7->UART1:RX1;    
    I2C1SCLPPS = 0x13;   //RC3->I2C1:SCL1;    

}



void main(void)
{
       
    SYSTEM_Initialize();
   
    Flag_Eeprom=0;
    for (i=0;i<sizeof(TEXTE);i++) TEXTE[i]=0;
    for (i=0;i<sizeof(Buffer1);i++) Buffer1[i]=0;
    for (i=0;i<sizeof(CRam1)-1;i++) CRam1[i]=0;
    for (i=0;i<9;i++) tmp[i]=0;
    txt=&TEXTE[0]; 
    
    Vectored_Interrupts_Init();
    Hardware_Init();
    
     #ifdef With Led_Rouge
    i=0;
    do
    {
      Led_Rouge=1;
       __delay_ms(200);
        Led_Rouge=0;
       __delay_ms(200);
      //      __asm("btg LATA,4") ;
         i++;  
    }
    while(i<8);
    Led_Rouge=1; // eteinte
   #endif
       
    UART1_Init();
    __delay_ms(100);
    CRLF1();
     CRLF1();
    CPrint(" Presentation :\r\n");       
    for (i=0;i<9;i++)   
    {
       CPrint(Messages[i]);
    }
    CRLF1();
    sprintf(txt," Compiled %s at %s UTC  version XC8 :%d \r\n", __DATE__, __TIME__,__XC8_VERSION);
    Print(txt);
    CRLF1();
    __delay_xSec(2);
    
#ifdef With_LCD    
    CPrint(" version Prototype : LCD Bleu a l'adresse 0x27 !\r\n");
     CPrint(" Init_I2C() 100Khz;\r\n");
    Init_I2C(); //SCLK=  500Khz / 5 = 100Khz
    CPrint(" Test presence devices sur Bus I2C1\r\n");
    Test_Presence_I2C_devices();
    CRLF1();
    
    Addr=LCD_ADDR; 
    NbCarPL=20; // LCD 4x20 !
    sprintf(CRam1," adresse LCD= %d soit 0X%02X \r\n",Addr,Addr);
    Print(CRam1);
    I2C1CON2bits.ABD=1;
    
    CPrint(" \r\nSequence d'Init LCD 4x20 via I2C1 PCF8574\r\n");
    I2C1CON0bits.EN=1;   
    LCD_init(); 
    CRLF1();
    LCD_Cmd(LCD_CLEAR);// 0x01
 
    LCD_Write_CText_At(1,1,"Version Prototype !");
     __delay_xSec(2); 
    LCD_Cmd(LCD_CLEAR);// 0x01
    LCD_Cmd(LCD_HOME); //  0x02
     __delay_ms(100); 
    CPrint(" Chargement caracteres Speciaux  en CGRAM\r\n");
    LCD_putsRom("Caracteres Speciaux ");
    LCD_Load_Custom_Chars(0);  // parametre:  0=mode silence,  1=bavard
    for (i=0;i<8;i++) 
    {
     //  CPrint(Special_Name1[i]); CRLF1();
       LCD_Chr_At(2,i+1,i);  
    }
     __delay_xSec(1);  
     
#endif
     
    CPrint(" Initialisation PWM1,2,3,4 avec FReq 3,9KHz (Timer2,Timer4)\r\n");
    PWM1_Initialize();
     PWM2_Initialize();
      PWM3_Initialize();
       PWM4_Initialize();
     CRLF1();  

     // armement capture reception UART
     RAZ_UART1_Buffer1();
     INTCON0bits.GIE=1;
     INTCON0bits.GIEH=1;
     
  #ifdef With_LCD     

    CPrint(" * PWM1 sur RC2 (TMR2)=20% \r\n");
    CPrint(" * PWM2 sur RC1 (TMR2)=40% \r\n");
    CPrint(" * PWM3 sur RB0 (TMR4)=60% \r\n");
    CPrint(" * PWM4 sur RB5 (TMR4)=80% \r\n"); 
     
    LCD_Cmd(LCD_CLEAR);// 0x01
    LCD_Cmd(LCD_HOME); //  0x02
    k=200;     F1=(float)k/10.2; PWM1_LoadDutyValue(k);
    sprintf(CRam1,"PWM1-RC2 %4d %3.1f%c",k,F1,'%');
    LCD_Write_Text_At(1,1,CRam1);
    k=400;     F2=(float)k/10.2; PWM1_LoadDutyValue(k);
    sprintf(CRam1,"PWM2-RC1 %4d %3.1f%c",k,F2,'%');
    LCD_Write_Text_At(2,1,CRam1);                
    k=600;     F3=(float)k/10.2; PWM1_LoadDutyValue(k);
    sprintf(CRam1,"PWM3-RB5 %4d %3.1f%c",k,F3,'%');
    LCD_Write_Text_At(3,1,CRam1);                
     k=800;     F4=(float)k/10.2; PWM1_LoadDutyValue(k);
    sprintf(CRam1,"PWM4-RB0 %4d %3.1f%c",k,F4,'%');
    LCD_Write_Text_At(4,1,CRam1);                
    
#endif
     CPrint(" Test differentes valeurs de Duty-cycle via le clavier terminal YAT \r\n");  
    
     do
   {
      CPrint("Entrer une valeur PWM=xxxx puis <enter> au clavier\r\n");
      RAZ_UART1_Buffer1(); // et arme interrupt UART RX
      // __delay_xSec(2);    // ajustement  delay de boucle principale   
        __delay_ms(1500);    //  
    	//__delay_xSec(3000-Delay_de_Boucle);  
       if(Flag_Buffer1==1)
       {
            CPrint("Recu :");
            Print(Buffer1);
            CRLF1();
            p0=&Buffer1[0];
	    
	        if ( (*(p0)=='P') && (*(p0+1)=='W') && ( *(p0+2)=='M') && ( *(p0+4)=='=') )
            { 
                cx=*(p0+3);
                m=0;
                if(  (isdigit(cx) & (cx>48) & (cx< 53))  ) // 1  4 seulement
                {  
                 m++;
                if (isdigit(*(p0+5))) { k=  (*(p0+5)-48)*1000; m++; }
                if (isdigit(*(p0+6))) { k=k+(*(p0+6)-48)*100; m++; }
                if (isdigit(*(p0+7))) { k=k+(*(p0+7)-48)*10; m++; }
                if (isdigit(*(p0+8))) { k=k+(*(p0+8)-48)*1; m++; }
                if ( (m==5) && (k<1016))
                {   
                   #ifdef With_SQA_Analyser 
                    SQA=1;
                    #endif
                     switch (cx)
                     {
                        case '1':
                            CPrint(" Saisie OK "); 
                            F1=(float)k/10.2;
                            #ifdef With_LCD   
                            sprintf(CRam1,"PWM1-RC2 %4d %3.1f%c",k,F1,'%');
                            LCD_Write_Text_At(1,1,CRam1);
                            #else
                            sprintf(CRam1," Saisie OK  PWM (CCP1 output RC2 ) = %5d soit %3.2f%c\r\n",k,F1,'%');
                            #endif
                            PWM1_LoadDutyValue(k);
                            break;
                        case '2':
                            F2=(float)k/10.2;
                            #ifdef With_LCD   
                            sprintf(CRam1,"PMW2-RC1 %4d %3.1f%c",k,F2,'%');
                            LCD_Write_Text_At(2,1,CRam1);
                            #else
                            sprintf(CRam1," Saisie OK  PWM (CCP2 output RC1 ) = %5d soit %3.2f%c\r\n",k,F2,'%');
                            #endif
                            PWM2_LoadDutyValue(k);
                            break;
                        case '3':
                            F3=(float)k/10.2;  
                            #ifdef With_LCD  
                            sprintf(CRam1,"PWM3-RB5 %4d %3.1f%c",k,F3,'%'); 
                            LCD_Write_Text_At(3,1,CRam1);
                             #else
                            sprintf(CRam1," Saisie OK  PWM (CCP3 output RB5 ) = %5d soit %3.2f%c\r\n",k,F3,'%');
                            #endif
                            PWM3_LoadDutyValue(k);
                            break;
                        case '4':
                            F4=(float)k/10.2;
                            #ifdef With_LCD   
                            sprintf(CRam1,"PWM4-RB0 %4d %3.1f%c",k,F4,'%');
                           LCD_Write_Text_At(4,1,CRam1);
                            #else
                              sprintf(CRam1," Saisie OK  PWM (CCP4 output RB0 ) = %5d soit %3.2f%c\r\n",k,F4,'%');
                            #endif
                            PWM4_LoadDutyValue(k);
                            break;
                        default :
                           cx=0; 
                           CPrint(" Erreur cx\r\n");
                           break;
                     }
                    if(cx>0)
                     { Print(CRam1);CRLF1();
                     __delay_ms(10);
                     }  
                    #ifdef With_SQA_Analyser 
                    SQA=0;
                    #endif  
                }
                else
                {
                     sprintf(CRam1," Erreur de Saisie  choix CCP %c valeur PWM %5d\r\n",cx,k);
                     Print(CRam1);
                     CPrint(" Rappel : cde PMWy=XXXX avec y=choix PMW 1 a 4 et  xxxx  valeur duty 0000 a 1015\r\n" );
                }
              }
            }
          p0=0;
          //  CRLF1();  
          Flag_Buffer1=0;
       }
        SQA=1;
        __delay_ms(100);
        SQA=0;
  } 
  while (1);
  
}
/**
 End of File
*/